Index: branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asmbgc.F90
===================================================================
--- branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asmbgc.F90	(revision 10574)
+++ branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asmbgc.F90	(revision 10622)
@@ -11,4 +11,5 @@
    !! 'key_medusa'          : MEDUSA model
    !! 'key_roam'            : MEDUSA extras for carbonate cycle
+   !! 'key_fabm'            : ERSEM model coupled via FABM
    !! 'key_karaml'          : Kara mixed layer depth
    !!---------------------------------------------------------------------------
@@ -38,5 +39,6 @@
       & ln_kara,            &
 #endif   
-      & hmld,               & 
+      & hmld,               &
+      & hmld_tref,          &
       & hmlp,               &
       & hmlpt 
@@ -45,19 +47,25 @@
       & c_asmbal,           &
       & nitbkg_r,           &
+      & nitavgbkg_r,        &
       & nitdin_r,           &
       & nitiaustr_r,        &
       & nitiaufin_r
+   USE asmphyto2dbal_medusa, ONLY: & ! phyto2d balancing for MEDUSA
+      & asm_phyto2d_bal_medusa
+   USE asmphyto2dbal_hadocc, ONLY: & ! phyto2d balancing for HadOCC
+      & asm_phyto2d_bal_hadocc
+   USE asmphyto2dbal_ersem,  ONLY: & ! phyto2d balancing for ERSEM
+      & asm_phyto2d_bal_ersem
+   USE asmpco2bal, ONLY:    & ! pCO2 balancing
+      & asm_pco2_bal
 #if defined key_top
    USE trc, ONLY:           & ! passive tracer variables
       & trn,                &
-      & trb
+      & trb,                &
+      & nittrc000
    USE par_trc, ONLY:       & ! passive tracer parameters
       & jptra
 #endif
 #if defined key_medusa
-   USE asmphyto2dbal_medusa, ONLY: & ! phyto2d balancing for MEDUSA
-      & asm_phyto2d_bal_medusa
-   USE asmpco2bal, ONLY:    & ! pCO2 balancing for MEDUSA
-      & asm_pco2_bal
    USE sms_medusa             ! MEDUSA parameters
    USE par_medusa             ! MEDUSA parameters
@@ -72,8 +80,4 @@
       & mld_max
 #elif defined key_hadocc
-   USE asmphyto2dbal_hadocc, ONLY: & ! phyto2d balancing for HadOCC
-      & asm_phyto2d_bal_hadocc
-   USE asmpco2bal, ONLY:    & ! pCO2 balancing for HadOCC
-      & asm_pco2_bal
    USE par_hadocc             ! HadOCC parameters
    USE had_bgc_const          ! HadOCC parameters
@@ -86,4 +90,11 @@
    USE had_bgc_const, ONLY: & ! HadOCC C:Chl ratio
       & cchl_p
+#elif defined key_fabm
+   USE par_fabm               ! FABM-ERSEM parameters
+   USE trc, ONLY:           & ! FABM-ERSEM diagnostic variables
+      & pgrow_avg,          &
+      & ploss_avg,          &
+      & phyt_avg,           &
+      & mld_max
 #endif
 
@@ -97,4 +108,6 @@
    PUBLIC  asm_bgc_init_bkg       ! called by asm_inc_init in asminc.F90
    PUBLIC  asm_bgc_bal_wri        ! called by nemo_gcm in nemogcm.F90
+   PUBLIC  asm_bgc_bkg_alloc      ! called by asm_bkg_wri in asmbkg.F90
+   PUBLIC  asm_bgc_bkg_tavg       ! called by asm_bkg_wri in asmbkg.F90
    PUBLIC  asm_bgc_bkg_wri        ! called by asm_bkg_wri in asmbkg.F90
    PUBLIC  phyto2d_asm_inc        ! called by bgc_asm_inc in asminc.F90
@@ -109,4 +122,7 @@
    LOGICAL, PUBLIC :: ln_slchldiainc = .FALSE. !: No surface diatom     log10(chlorophyll) increment
    LOGICAL, PUBLIC :: ln_slchlnoninc = .FALSE. !: No surface non-diatom log10(chlorophyll) increment
+   LOGICAL, PUBLIC :: ln_slchlnaninc = .FALSE. !: No surface nanophyto  log10(chlorophyll) increment
+   LOGICAL, PUBLIC :: ln_slchlpicinc = .FALSE. !: No surface picophyto  log10(chlorophyll) increment
+   LOGICAL, PUBLIC :: ln_slchldininc = .FALSE. !: No surface dinoflag   log10(chlorophyll) increment
    LOGICAL, PUBLIC :: ln_schltotinc  = .FALSE. !: No surface total      chlorophyll        increment
    LOGICAL, PUBLIC :: ln_slphytotinc = .FALSE. !: No surface total      log10(phyto C)     increment
@@ -146,4 +162,7 @@
    REAL(wp), DIMENSION(:,:),     ALLOCATABLE :: slchldia_bkginc ! slchldia inc
    REAL(wp), DIMENSION(:,:),     ALLOCATABLE :: slchlnon_bkginc ! slchlnon inc
+   REAL(wp), DIMENSION(:,:),     ALLOCATABLE :: slchlnan_bkginc ! slchlnan inc
+   REAL(wp), DIMENSION(:,:),     ALLOCATABLE :: slchlpic_bkginc ! slchlpic inc
+   REAL(wp), DIMENSION(:,:),     ALLOCATABLE :: slchldin_bkginc ! slchldin inc
    REAL(wp), DIMENSION(:,:),     ALLOCATABLE :: schltot_bkginc  ! schltot inc
    REAL(wp), DIMENSION(:,:),     ALLOCATABLE :: slphytot_bkginc ! slphytot inc
@@ -172,4 +191,18 @@
    REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE :: chl_bkg         ! Background chl
    REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE :: cchl_p_bkg      ! Background c:chl
+#if defined key_fabm
+   REAL(wp), DIMENSION(:,:,:),   ALLOCATABLE :: totalk_bkg      ! Background total alkalinity
+#endif
+
+   REAL(wp), DIMENSION(:,:),     SAVE, ALLOCATABLE :: pgrow_avg_tavg  ! Time average of pgrow_avg
+   REAL(wp), DIMENSION(:,:),     SAVE, ALLOCATABLE :: ploss_avg_tavg  ! Time average of ploss_avg
+   REAL(wp), DIMENSION(:,:),     SAVE, ALLOCATABLE :: phyt_avg_tavg   ! Time average of phyt_avg
+   REAL(wp), DIMENSION(:,:,:,:), SAVE, ALLOCATABLE :: trn_tavg        ! Time average of trn
+#if defined key_hadocc
+   REAL(wp), DIMENSION(:,:,:),   SAVE, ALLOCATABLE :: HADOCC_CHL_tavg ! Time average of HADOCC_CHL
+   REAL(wp), DIMENSION(:,:,:),   SAVE, ALLOCATABLE :: cchl_p_tavg     ! Time average of cchl_p
+#elif defined key_fabm
+   REAL(wp), DIMENSION(:,:,:),   SAVE, ALLOCATABLE :: totalk_tavg     ! Time average of O3_TA
+#endif
 
 #  include "domzgr_substitute.h90"
@@ -190,5 +223,5 @@
       !!------------------------------------------------------------------------
 
-#if ! defined key_top || ( ! defined key_hadocc && ! defined key_medusa )
+#if ! defined key_top || ( ! defined key_hadocc && ! defined key_medusa && ! defined key_fabm )
       CALL ctl_stop( ' Attempting to assimilate biogeochemical observations', &
          &           ' but no compatible biogeochemical model is available' )
@@ -208,9 +241,16 @@
 #endif
 
+#if defined key_fabm
+      IF ( ln_pphinc ) THEN
+         CALL ctl_stop( ' Cannot currently assimilate pH into FABM-ERSEM' )
+      ENDIF
+#endif
+
       IF ( ( ln_phytobal ).AND.                                       &
          & ( .NOT. ln_slchltotinc ).AND.( .NOT. ln_slchldiainc ).AND. &
-         & ( .NOT. ln_slchlnoninc ).AND.( .NOT. ln_schltotinc  ).AND. &
-         & ( .NOT. ln_slphytotinc ).AND.( .NOT. ln_slphydiainc ).AND. &
-         & ( .NOT. ln_slphynoninc ) ) THEN
+         & ( .NOT. ln_slchlnoninc ).AND.( .NOT. ln_slchlnaninc ).AND. &
+         & ( .NOT. ln_slchlpicinc ).AND.( .NOT. ln_slchldininc ).AND. &
+         & ( .NOT. ln_schltotinc  ).AND.( .NOT. ln_slphytotinc ).AND. &
+         & ( .NOT. ln_slphydiainc ).AND.( .NOT. ln_slphynoninc ) ) THEN
          CALL ctl_warn( ' Cannot calculate phytoplankton balancing increments', &
             &           ' if not assimilating ocean colour,',                   &
@@ -221,5 +261,7 @@
       IF ( ( ln_balwri ).AND.                                         &
          & ( .NOT. ln_slchltotinc ).AND.( .NOT. ln_slchldiainc ).AND. &
-         & ( .NOT. ln_slchlnoninc ).AND.( .NOT. ln_schltotinc  ).AND. &
+         & ( .NOT. ln_slchlnoninc ).AND.( .NOT. ln_slchlnaninc ).AND. &
+         & ( .NOT. ln_slchlpicinc ).AND.( .NOT. ln_slchldininc ).AND. &
+         & ( .NOT. ln_schltotinc  ).AND.                              &
          & ( .NOT. ln_slphytotinc ).AND.( .NOT. ln_slphydiainc ).AND. &
          & ( .NOT. ln_slphynoninc ).AND.( .NOT. ln_plchltotinc ).AND. &
@@ -244,5 +286,6 @@
 
       IF ( ( ln_slchltotinc .OR. ln_schltotinc  ) .AND. &
-         & ( ln_slchldiainc .OR. ln_slchlnoninc ) ) THEN
+         & ( ln_slchldiainc .OR. ln_slchlnoninc .OR. ln_slchlnaninc .OR. &
+         &   ln_slchlpicinc .OR. ln_slchldininc ) ) THEN
          CALL ctl_stop( ' Can only assimilate total or PFT surface chlorophyll, not both' )
       ENDIF
@@ -250,4 +293,9 @@
       IF ( ln_phytobal .AND.                                      &
          & ( ( ln_slchlnoninc .AND.( .NOT. ln_slchldiainc ) ).OR. &
+#if defined key_fabm
+         &   (  ( ln_slchldiainc .OR. ln_slchlnaninc .OR. ln_slchlpicinc .OR. ln_slchldininc ) .AND. &
+         &      ( ( .NOT. ln_slchldiainc ) .OR. ( .NOT. ln_slchlnaninc ) .OR. &
+         &        ( .NOT. ln_slchlpicinc ) .OR. ( .NOT. ln_slchldininc ) ) ) .OR. &
+#endif
          &   ( ln_slchldiainc .AND.( .NOT. ln_slchlnoninc ) ) ) ) THEN
          CALL ctl_stop( ' Cannot calculate phytoplankton balancing increments', &
@@ -306,4 +354,19 @@
       ENDIF
       
+      IF ( ln_slchlnaninc ) THEN
+         ALLOCATE( slchlnan_bkginc(jpi,jpj) )
+         CALL asm_bgc_read_incs_2d( knum, 'bckinslchlnan', slchlnan_bkginc )
+      ENDIF
+      
+      IF ( ln_slchlpicinc ) THEN
+         ALLOCATE( slchlpic_bkginc(jpi,jpj) )
+         CALL asm_bgc_read_incs_2d( knum, 'bckinslchlpic', slchlpic_bkginc )
+      ENDIF
+      
+      IF ( ln_slchldininc ) THEN
+         ALLOCATE( slchldin_bkginc(jpi,jpj) )
+         CALL asm_bgc_read_incs_2d( knum, 'bckinslchldin', slchldin_bkginc )
+      ENDIF
+      
       IF ( ln_schltotinc ) THEN
          ALLOCATE( schltot_bkginc(jpi,jpj) )
@@ -379,4 +442,5 @@
       
       IF ( ln_slchltotinc .OR. ln_slchldiainc .OR. ln_slchlnoninc .OR. &
+         & ln_slchlnaninc .OR. ln_slchlpicinc .OR. ln_slchldininc .OR. &
          & ln_schltotinc  .OR. ln_slphytotinc .OR. ln_slphydiainc .OR. &
          & ln_slphynoninc ) THEN
@@ -516,6 +580,7 @@
       !!------------------------------------------------------------------------
 
-#if defined key_top && ( defined key_hadocc || defined key_medusa )
+#if defined key_top && ( defined key_hadocc || defined key_medusa || defined key_fabm )
       IF ( ln_slchltotinc .OR. ln_slchldiainc .OR. ln_slchlnoninc .OR. &
+         & ln_slchlnaninc .OR. ln_slchlpicinc .OR. ln_slchldininc .OR. &
          & ln_schltotinc  .OR. ln_slphytotinc .OR. ln_slphydiainc .OR. &
          & ln_slphynoninc .OR. ln_plchltotinc .OR. ln_pchltotinc ) THEN
@@ -557,4 +622,22 @@
          CALL iom_get( inum, jpdom_autoglo, 'medusa_phd', tracer_bkg(:,:,:,jpphd) )
          CALL iom_get( inum, jpdom_autoglo, 'medusa_pds', tracer_bkg(:,:,:,jppds) )
+#elif defined key_fabm
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_chl1', tracer_bkg(:,:,:,jp_fabm_chl1) )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_chl2', tracer_bkg(:,:,:,jp_fabm_chl2) )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_chl3', tracer_bkg(:,:,:,jp_fabm_chl3) )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_chl4', tracer_bkg(:,:,:,jp_fabm_chl4) )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_p1c',  tracer_bkg(:,:,:,jp_fabm_p1c)  )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_p1n',  tracer_bkg(:,:,:,jp_fabm_p1n)  )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_p1p',  tracer_bkg(:,:,:,jp_fabm_p1p)  )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_p1s',  tracer_bkg(:,:,:,jp_fabm_p1s)  )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_p2c',  tracer_bkg(:,:,:,jp_fabm_p2c)  )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_p2n',  tracer_bkg(:,:,:,jp_fabm_p2n)  )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_p2p',  tracer_bkg(:,:,:,jp_fabm_p2p)  )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_p3c',  tracer_bkg(:,:,:,jp_fabm_p3c)  )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_p3n',  tracer_bkg(:,:,:,jp_fabm_p3n)  )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_p3p',  tracer_bkg(:,:,:,jp_fabm_p3p)  )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_p4c',  tracer_bkg(:,:,:,jp_fabm_p4c)  )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_p4n',  tracer_bkg(:,:,:,jp_fabm_p4n)  )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_p4p',  tracer_bkg(:,:,:,jp_fabm_p4p)  )
 #endif
          
@@ -588,4 +671,21 @@
             CALL iom_get( inum, jpdom_autoglo, 'medusa_alk', tracer_bkg(:,:,:,jpalk) )
             CALL iom_get( inum, jpdom_autoglo, 'medusa_oxy', tracer_bkg(:,:,:,jpoxy) )
+#elif defined key_fabm
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_z4c',  tracer_bkg(:,:,:,jp_fabm_z4c)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_z5c',  tracer_bkg(:,:,:,jp_fabm_z5c)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_z5n',  tracer_bkg(:,:,:,jp_fabm_z5n)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_z5p',  tracer_bkg(:,:,:,jp_fabm_z5p)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_z6c',  tracer_bkg(:,:,:,jp_fabm_z6c)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_z6n',  tracer_bkg(:,:,:,jp_fabm_z6n)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_z6p',  tracer_bkg(:,:,:,jp_fabm_z6p)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_n1p',  tracer_bkg(:,:,:,jp_fabm_n1p)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_n3n',  tracer_bkg(:,:,:,jp_fabm_n3n)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_n4n',  tracer_bkg(:,:,:,jp_fabm_n4n)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_n5s',  tracer_bkg(:,:,:,jp_fabm_n5s)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_o2o',  tracer_bkg(:,:,:,jp_fabm_o2o)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_o3c',  tracer_bkg(:,:,:,jp_fabm_o3c)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_o3ba', tracer_bkg(:,:,:,jp_fabm_o3ba) )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_o3ta', totalk_bkg(:,:,:)              )
+            totalk_bkg(:,:,:) = totalk_bkg(:,:,:) * tmask(:,:,:)
 #endif
          ELSE IF ( ln_spco2inc .OR. ln_sfco2inc .OR. ln_pphinc ) THEN
@@ -596,4 +696,9 @@
             CALL iom_get( inum, jpdom_autoglo, 'medusa_dic', tracer_bkg(:,:,:,jpdic) )
             CALL iom_get( inum, jpdom_autoglo, 'medusa_alk', tracer_bkg(:,:,:,jpalk) )
+#elif defined key_fabm
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_o3c',  tracer_bkg(:,:,:,jp_fabm_o3c)  )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_o3ba', tracer_bkg(:,:,:,jp_fabm_o3ba) )
+            CALL iom_get( inum, jpdom_autoglo, 'ersem_o3ta', totalk_bkg(:,:,:)              )
+            totalk_bkg(:,:,:) = totalk_bkg(:,:,:) * tmask(:,:,:)
 #endif
             CALL iom_get( inum, jpdom_autoglo, 'mld_max',   mld_max_bkg   )
@@ -622,4 +727,9 @@
          CALL iom_get( inum, jpdom_autoglo, 'medusa_dic', tracer_bkg(:,:,:,jpdic) )
          CALL iom_get( inum, jpdom_autoglo, 'medusa_alk', tracer_bkg(:,:,:,jpalk) )
+#elif defined key_fabm
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_o3c',  tracer_bkg(:,:,:,jp_fabm_o3c)  )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_o3ba', tracer_bkg(:,:,:,jp_fabm_o3ba) )
+         CALL iom_get( inum, jpdom_autoglo, 'ersem_o3ta', totalk_bkg(:,:,:)              )
+         totalk_bkg(:,:,:) = totalk_bkg(:,:,:) * tmask(:,:,:)
 #endif
          CALL iom_get( inum, jpdom_autoglo, 'mld_max',   mld_max_bkg   )
@@ -687,4 +797,5 @@
 
          IF ( ln_slchltotinc .OR. ln_slchldiainc .OR. ln_slchlnoninc .OR. &
+            & ln_slchlnaninc .OR. ln_slchlpicinc .OR. ln_slchldininc .OR. &
             & ln_schltotinc  .OR. ln_slphytotinc .OR. ln_slphydiainc .OR. &
             & ln_slphynoninc ) THEN
@@ -716,4 +827,38 @@
                CALL iom_rstput( kt, kt, inum, 'phy2d_alk', phyto2d_balinc(:,:,:,jp_had_alk) )
             ENDIF
+#elif defined key_fabm
+            CALL iom_rstput( kt, kt, inum, 'phy2d_chl1', phyto2d_balinc(:,:,:,jp_fabm_chl1) )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_chl2', phyto2d_balinc(:,:,:,jp_fabm_chl2) )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_chl3', phyto2d_balinc(:,:,:,jp_fabm_chl3) )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_chl4', phyto2d_balinc(:,:,:,jp_fabm_chl4) )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_p1c',  phyto2d_balinc(:,:,:,jp_fabm_p1c)  )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_p1n',  phyto2d_balinc(:,:,:,jp_fabm_p1n)  )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_p1p',  phyto2d_balinc(:,:,:,jp_fabm_p1p)  )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_p1s',  phyto2d_balinc(:,:,:,jp_fabm_p1s)  )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_p2c',  phyto2d_balinc(:,:,:,jp_fabm_p2c)  )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_p2n',  phyto2d_balinc(:,:,:,jp_fabm_p2n)  )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_p2p',  phyto2d_balinc(:,:,:,jp_fabm_p2p)  )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_p3c',  phyto2d_balinc(:,:,:,jp_fabm_p3c)  )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_p3n',  phyto2d_balinc(:,:,:,jp_fabm_p3n)  )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_p3p',  phyto2d_balinc(:,:,:,jp_fabm_p3p)  )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_p4c',  phyto2d_balinc(:,:,:,jp_fabm_p4c)  )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_p4n',  phyto2d_balinc(:,:,:,jp_fabm_p4n)  )
+            CALL iom_rstput( kt, kt, inum, 'phy2d_p4p',  phyto2d_balinc(:,:,:,jp_fabm_p4p)  )
+            IF ( ln_phytobal ) THEN
+               CALL iom_rstput( kt, kt, inum, 'phy2d_z4c',   phyto2d_balinc(:,:,:,jp_fabm_z4c)  )
+               CALL iom_rstput( kt, kt, inum, 'phy2d_z5c',   phyto2d_balinc(:,:,:,jp_fabm_z5c)  )
+               CALL iom_rstput( kt, kt, inum, 'phy2d_z5n',   phyto2d_balinc(:,:,:,jp_fabm_z5n)  )
+               CALL iom_rstput( kt, kt, inum, 'phy2d_z5p',   phyto2d_balinc(:,:,:,jp_fabm_z5p)  )
+               CALL iom_rstput( kt, kt, inum, 'phy2d_z6c',   phyto2d_balinc(:,:,:,jp_fabm_z6c)  )
+               CALL iom_rstput( kt, kt, inum, 'phy2d_z6n',   phyto2d_balinc(:,:,:,jp_fabm_z6n)  )
+               CALL iom_rstput( kt, kt, inum, 'phy2d_z6p',   phyto2d_balinc(:,:,:,jp_fabm_z6p)  )
+               CALL iom_rstput( kt, kt, inum, 'phy2d_n1p',   phyto2d_balinc(:,:,:,jp_fabm_n1p)  )
+               CALL iom_rstput( kt, kt, inum, 'phy2d_n3n',   phyto2d_balinc(:,:,:,jp_fabm_n3n)  )
+               CALL iom_rstput( kt, kt, inum, 'phy2d_n4n',   phyto2d_balinc(:,:,:,jp_fabm_n4n)  )
+               CALL iom_rstput( kt, kt, inum, 'phy2d_n5s',   phyto2d_balinc(:,:,:,jp_fabm_n5s)  )
+               CALL iom_rstput( kt, kt, inum, 'phy2d_o2o',   phyto2d_balinc(:,:,:,jp_fabm_o2o)  )
+               CALL iom_rstput( kt, kt, inum, 'phy2d_o3c',   phyto2d_balinc(:,:,:,jp_fabm_o3c)  )
+               CALL iom_rstput( kt, kt, inum, 'phy2d_o3ba',  phyto2d_balinc(:,:,:,jp_fabm_o3ba) )
+            ENDIF
 #endif
          ENDIF
@@ -728,4 +873,22 @@
 #elif defined key_hadocc
             CALL iom_rstput( kt, kt, inum, 'phy3d_phy', phyto3d_balinc(:,:,:,jp_had_phy) )
+#elif defined key_fabm
+            CALL iom_rstput( kt, kt, inum, 'phy3d_chl1', phyto3d_balinc(:,:,:,jp_fabm_chl1) )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_chl2', phyto3d_balinc(:,:,:,jp_fabm_chl2) )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_chl3', phyto3d_balinc(:,:,:,jp_fabm_chl3) )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_chl4', phyto3d_balinc(:,:,:,jp_fabm_chl4) )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_p1c',  phyto3d_balinc(:,:,:,jp_fabm_p1c)  )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_p1n',  phyto3d_balinc(:,:,:,jp_fabm_p1n)  )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_p1p',  phyto3d_balinc(:,:,:,jp_fabm_p1p)  )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_p1s',  phyto3d_balinc(:,:,:,jp_fabm_p1s)  )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_p2c',  phyto3d_balinc(:,:,:,jp_fabm_p2c)  )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_p2n',  phyto3d_balinc(:,:,:,jp_fabm_p2n)  )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_p2p',  phyto3d_balinc(:,:,:,jp_fabm_p2p)  )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_p3c',  phyto3d_balinc(:,:,:,jp_fabm_p3c)  )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_p3n',  phyto3d_balinc(:,:,:,jp_fabm_p3n)  )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_p3p',  phyto3d_balinc(:,:,:,jp_fabm_p3p)  )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_p4c',  phyto3d_balinc(:,:,:,jp_fabm_p4c)  )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_p4n',  phyto3d_balinc(:,:,:,jp_fabm_p4n)  )
+            CALL iom_rstput( kt, kt, inum, 'phy3d_p4p',  phyto3d_balinc(:,:,:,jp_fabm_p4p)  )
 #endif
          ENDIF
@@ -738,4 +901,7 @@
             CALL iom_rstput( kt, kt, inum, 'pco2_dic', pco2_balinc(:,:,:,jp_had_dic) )
             CALL iom_rstput( kt, kt, inum, 'pco2_alk', pco2_balinc(:,:,:,jp_had_alk) )
+#elif defined key_fabm
+            CALL iom_rstput( kt, kt, inum, 'pco2_o3c',  pco2_balinc(:,:,:,jp_fabm_o3c)  )
+            CALL iom_rstput( kt, kt, inum, 'pco2_o3ba', pco2_balinc(:,:,:,jp_fabm_o3ba) )
 #endif
          ELSE IF ( ln_sfco2inc ) THEN
@@ -746,4 +912,7 @@
             CALL iom_rstput( kt, kt, inum, 'fco2_dic', pco2_balinc(:,:,:,jp_had_dic) )
             CALL iom_rstput( kt, kt, inum, 'fco2_alk', pco2_balinc(:,:,:,jp_had_alk) )
+#elif defined key_fabm
+            CALL iom_rstput( kt, kt, inum, 'fco2_o3c',  pco2_balinc(:,:,:,jp_fabm_o3c)  )
+            CALL iom_rstput( kt, kt, inum, 'fco2_o3ba', pco2_balinc(:,:,:,jp_fabm_o3ba) )
 #endif
          ENDIF
@@ -756,4 +925,7 @@
             CALL iom_rstput( kt, kt, inum, 'ph_dic', ph_balinc(:,:,:,jp_had_dic) )
             CALL iom_rstput( kt, kt, inum, 'ph_alk', ph_balinc(:,:,:,jp_had_alk) )
+#elif defined key_fabm
+            CALL iom_rstput( kt, kt, inum, 'ph_o3c',  ph_balinc(:,:,:,jp_fabm_o3c)  )
+            CALL iom_rstput( kt, kt, inum, 'ph_o3ba', ph_balinc(:,:,:,jp_fabm_o3ba) )
 #endif
          ENDIF
@@ -774,5 +946,73 @@
    !!===========================================================================
 
-   SUBROUTINE asm_bgc_bkg_wri( kt, knum )
+   SUBROUTINE asm_bgc_bkg_alloc
+      !!------------------------------------------------------------------------
+      !!                    ***  ROUTINE asm_bgc_bkg_alloc  ***
+      !!
+      !! ** Purpose :   allocate time-average arrays for background
+      !!
+      !! ** Method  :   allocate time-average arrays for background
+      !!
+      !! ** Action  :   allocate time-average arrays for background
+      !!
+      !! References :   asm_bkg_wri
+      !!------------------------------------------------------------------------
+      !!
+      INTEGER :: ierror
+      !!
+      !!------------------------------------------------------------------------
+      
+      ALLOCATE( pgrow_avg_tavg(jpi,jpj), STAT=ierror )
+      IF( ierror > 0 ) THEN
+         CALL ctl_stop( 'asm_bgc_bkg_alloc: unable to allocate pgrow_avg_tavg' )
+      ENDIF
+      pgrow_avg_tavg(:,:) = 0.0
+      
+      ALLOCATE( ploss_avg_tavg(jpi,jpj), STAT=ierror )
+      IF( ierror > 0 ) THEN
+         CALL ctl_stop( 'asm_bgc_bkg_alloc: unable to allocate ploss_avg_tavg' )
+      ENDIF
+      ploss_avg_tavg(:,:) = 0.0
+      
+      ALLOCATE( phyt_avg_tavg(jpi,jpj), STAT=ierror )
+      IF( ierror > 0 ) THEN
+         CALL ctl_stop( 'asm_bgc_bkg_alloc: unable to allocate phyt_avg_tavg' )
+      ENDIF
+      phyt_avg_tavg(:,:) = 0.0
+      
+      ALLOCATE( trn_tavg(jpi,jpj,jpk,jptra), STAT=ierror )
+      IF( ierror > 0 ) THEN
+         CALL ctl_stop( 'asm_bgc_bkg_alloc: unable to allocate trn_tavg' )
+      ENDIF
+      trn_tavg(:,:,:,:) = 0.0
+
+#if defined key_hadocc
+      ALLOCATE( HADOCC_CHL_tavg(jpi,jpj,jpk), STAT=ierror )
+      IF( ierror > 0 ) THEN
+         CALL ctl_stop( 'asm_bgc_bkg_alloc: unable to allocate HADOCC_CHL_tavg' )
+      ENDIF
+      HADOCC_CHL_tavg(:,:,:) = 0.0
+
+      ALLOCATE( cchl_p_tavg(jpi,jpj,jpk), STAT=ierror )
+      IF( ierror > 0 ) THEN
+         CALL ctl_stop( 'asm_bgc_bkg_alloc: unable to allocate cchl_p_tavg' )
+      ENDIF
+      cchl_p_tavg(:,:,:) = 0.0
+
+#elif defined key_fabm
+      ALLOCATE( totalk_tavg(jpi,jpj,jpk), STAT=ierror )
+      IF( ierror > 0 ) THEN
+         CALL ctl_stop( 'asm_bgc_bkg_alloc: unable to allocate totalk_tavg' )
+      ENDIF
+      totalk_tavg(:,:,:) = 0.0
+#endif
+                                 
+   END SUBROUTINE asm_bgc_bkg_alloc
+
+   !!===========================================================================
+   !!===========================================================================
+   !!===========================================================================
+
+   SUBROUTINE asm_bgc_bkg_tavg(kt, pnumtimes_tavg)
       !!------------------------------------------------------------------------
       !!                    ***  ROUTINE asm_bgc_bkg_wri  ***
